def function(x):
    return x**3 -10*x**2+5
    
def bisection(f,a,b,toll):
    """
Funzione bisection per il calcolo degli zeri di una funzione f nell'intervallo [a,b].
ARGUMENTS:
f ---> funzione
a ---> estremo sx dell'intervallo
b ---> estremo dx dell'intervallo
toll ---> tolleranza richiesta
RETURN:
x ---> zero della funzione
    """
    if f(a)==0.0: return a
    if f(b)==0.0: return b
    if f(a)*f(b)>0.0:
        print "Non ci sono Zeri"
        return None
    m=float((a+b))/2
    if f(m)==0.0: return m
    if f(a)*f(m)<0.0:
        if abs(m-a)>toll:
            return bisection(f,a,m,toll)
        else:
            return float(a+m)/2
    elif f(b)*f(m)<0.0:
        if abs(m-b)>toll:
            return bisection(f,m,b,toll)
        else:
            return float(b+m)/2

a=0
b=1
zero=bisection(function,a,b,1.0e-15)
print "Zero ", zero
    
