import sys
def prod_vect(v1,v2):
    """Funzione che implementa il prodotto scalare tra v1 e v2
       ARGUMENT:
       v1 vettore 1
       v2 vettore 2
       RETURN:
       val prodotto
    """
    try:
      if len(v1)!= len(v2):
        raise Exception , "I vettori devono avere la stessa dimensione"
      ssum=0.0
      for i in range(len(v1)):
          ssum+=v1[i]*v2[i]
      return ssum
    except Exception,e:
      print e
      
def prod_vect_lambda(v1,v2):
  try:
      if len(v1)!=len(v2):
        raise Exception, 'I vettori devono avere la stessa dimensione'
      m=reduce(lambda x,y: x+y, map(lambda x,y: x*y,v1,v2))
      return m
  except Exception,e:
    print e

v1=[1.0,2.0,3.0, 4.0]
v2=[1.0,2.0,3.0,1.5]

print "Funzione prod_vect"
print "Prodotto scalare tra " , v1 , " e ", v2
print prod_vect(v1,v2)

print "Tramite lambda function"
print "prodotto ", prod_vect_lambda(v1,v2)

